/*
 * CacheManager.java
 *
 * Created on 2004/10/27, 23:50
 */

package net.sourceforge.shingetsu.cache;

import java.io.File;
import java.util.Enumeration;
import java.util.Vector;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.security.MessageDigest;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.io.DataFilenameFilter;
import net.sourceforge.shingetsu.server.cgi.PlugIn;
import net.sourceforge.shingetsu.util.Config;

import java.lang.NullPointerException;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.security.NoSuchAlgorithmException;

/**
 * [J̃LbVǗ邽߂̃}l[WNXłBV擾R[
 * hƃLbVt@C̃R[hƂ̔rAȂǃLbVt@C̊ԐړI
 * sƂł܂B
 * @author stokesia
 */
public class CacheManager {
    
    private Config config = Config.getInstance();
    
    /** Creates a new instance of CacheManager */
    public CacheManager() {
    }
    
    /**
     * LbVt@Cƈ̃R[hƂ𓯊܂BVR[h΃Lb
     * Vt@Cɏ܂܂B
     * @param cache LbVt@C
     * @param records 郌R[hz
     * @throws IOException o͒ɃG[ꍇ
     * @throws FileNotFoundException LbVt@C݂Ȃꍇ
     * @throws NoSuchAlgorithmException MD5ASY̎w肪sȏꍇ
     * @throws UnsupportedEncodingException w肳ꂽGR[fBOT|[gĂȂꍇ
     */    
    public void synchronize(Cache cache, String[] records) throws IOException, 
        FileNotFoundException , NoSuchAlgorithmException, UnsupportedEncodingException {
        int limit = 3;    
        
        cache.lock();
        
        for(int i = 0; i < records.length; i++) {
            String record = records[i];
            
            String[] tokens = record.split("<>", limit);
            
            String timeStamp = tokens[0];
            String id = tokens[1];
            String body = tokens[2];
            
            long time = 0L;
            
            try {
                time = Long.parseLong(timeStamp);
            } catch(NumberFormatException e) {
                continue;
            }
            
            if(!cache.containsRecord(time, id)) {
                if(config.isCheckMD5() && getMD5(body).equals(id)) {
                    cache.append(record);
                } else {
                    cache.append(record);
                }
            }
            
        }
        
        cache.unlock();
        
    }
     
    /**
     * LbVt@C̃fBNgLbVt@C̔z擾܂B
     * @return LbVt@C̔z
     */    
     public Cache[] getCaches() {
         String dataDirectoryPath = config.getDataDirectory() + File.separator;
         
         File dataDirectory = new File(dataDirectoryPath);
         File[] cacheFiles = dataDirectory.listFiles(new DataFilenameFilter());
         
         Vector cacheFileList = createCacheFileList(cacheFiles);
         
         Cache[] caches = new Cache[cacheFileList.size()];
         
         Enumeration enumeration = cacheFileList.elements();
         
         for(int i = 0; enumeration.hasMoreElements(); i++) {
             caches[i] = (Cache) enumeration.nextElement();
         }
         
         return caches;
     }
     
     /**
      * LbVt@C̃fBNgw肳ꂽLbVt@C̔z擾܂B
      * @param type VŒ`Ă^Cv
      * @return w肳ꂽ^CṽLbVt@C̔z
      */     
     public Cache[] getCaches(String type) {
         String dataDirectoryPath = config.getDataDirectory() + File.separator;
         
         File dataDirectory = new File(dataDirectoryPath);
         File[] cacheFiles = dataDirectory.listFiles(new DataFilenameFilter(type));
         
         Vector cacheFileList = createCacheFileList(cacheFiles);
         
         Cache[] caches = new Cache[cacheFileList.size()];
         
         Enumeration enumeration = cacheFileList.elements();
         
         for(int i = 0; enumeration.hasMoreElements(); i++) {
             caches[i] = (Cache) enumeration.nextElement();
         }
         
         return caches;
     }
     
     /**
      * LbVt@C̃fBNgLbVt@C̗񋓎q擾܂B
      * @return LbVt@C̗񋓎q
      */     
     public Enumeration enumeration() {
         String dataDirectoryPath = config.getDataDirectory() + File.separator;
         
         File dataDirectory = new File(dataDirectoryPath);
         File[] cacheFiles = dataDirectory.listFiles(new DataFilenameFilter());
         
         Vector cacheFileList = createCacheFileList(cacheFiles);
         
         return cacheFileList.elements();
     }
     
     /**
      * LbVt@C̃fBNgw肳ꂽLbVt@C̗񋓎q擾
      * ܂B
      * @param type VŒ`Ă^Cv
      * @return LbVt@C̗񋓎q
      */     
     public Enumeration enumeration(String type) {
         String dataDirectoryPath = config.getDataDirectory() + File.separator;
         
         File dataDirectory = new File(dataDirectoryPath);
         File[] cacheFiles = dataDirectory.listFiles(new DataFilenameFilter(type));
         
         Vector cacheFileList = createCacheFileList(cacheFiles);

         return cacheFileList.elements();
     }
     
     private Vector createCacheFileList(File[] cacheFiles) {
         Vector cacheFileList = new Vector();
         
         for(int i = 0; i < cacheFiles.length; i++) {
             if(!cacheFiles[i].exists()) {
                 continue;
             }
             
             Cache cache = null;
             
             try {
                 cache = new Cache(cacheFiles[i]);
                 cacheFileList.add(cache);
             } catch(FileNotFoundException e) {
                System.err.println("t@C " + cacheFiles[i].getName() + " ݂܂B");
                e.printStackTrace();
             } catch(NullPointerException e) {
                System.err.println("t@Cւ̎QƂnullłB");
                e.printStackTrace();
             } catch(IOException e) {
                System.err.println("t@Cƃ`l̊֘AtɎs܂B");
                e.printStackTrace();
             }

         }
         
         return cacheFileList;
     }
     
     /**
      * LbVt@C̃R[hƈ̃R[hƂœ̃eXgs܂BA
      * LbVt@CɈ̃R[h܂܂ĂȂΖ߂l̔zɊ܂܂܂B
      * @param cache LbVt@C
      * @param records String^̃R[hz
      * @throws FileNotFoundException LbVt@C݂Ȃꍇ
      * @return LbVt@CɊ܂܂ĂȂR[h̔z
      */     
     public String[] difference(Cache cache, String[] records) throws FileNotFoundException {
         int timeStampGroup = 1;
         int idGroup = 2;
         
         Vector differenceList = new Vector();
         
         for(int i = 0; i < records.length; i++) {
             String record = records[i];
             
             String regex = "^(\\d+)<>([0-9a-f]+)";
             Matcher matcher = Pattern.compile(regex).matcher(record);
             
             matcher.find();
             
             String timeStamp = matcher.group(timeStampGroup);
             String id =matcher.group(idGroup);
             
             long time = 0L;
             
             try {
                 time = Long.parseLong(timeStamp);
                 
                 if((cache.getRecordCount() == 0) || (!cache.containsRecord(time, id))) {
                     differenceList.add(record);
                 }
             } catch(NumberFormatException e) {
                 continue;
             } catch(IOException e) {
                 System.out.println("o͒ɃG[܂B");
                 e.printStackTrace();
             }
         }
         
         Enumeration enumeration = differenceList.elements();
         records = new String[differenceList.size()];
         
         for(int i = 0; enumeration.hasMoreElements(); i++) {
             records[i] = (String) enumeration.nextElement();
         }

         return records;
     }
     
    private String getMD5(String value)
        throws UnsupportedEncodingException, NoSuchAlgorithmException {
        MessageDigest md5 = MessageDigest.getInstance("MD5");
        
        String encoding = config.getGeneralEncoding();
        byte[] valueArray = value.getBytes(encoding);
        
        md5.update(valueArray, 0, valueArray.length);
        byte[] digest = md5.digest();
        
        StringBuffer hexStringBuffer = new StringBuffer();
        
        for(int i = 0; i < digest.length; i++) {
            int n = digest[i] & 0xFF;
            
            if(n < 16) {
                hexStringBuffer.append("0");
            }
            
            hexStringBuffer.append(Integer.toHexString(n));
        }
        
        return hexStringBuffer.toString();
    }
    
}
