/*
 * NodeWriter.java
 *
 * Created on 2004/07/17, 16:52
 */

package net.sourceforge.shingetsu.io;

import java.io.File;
import java.util.Vector;
import java.util.Enumeration;

import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.io.MultipleLineWriter;

import java.net.MalformedURLException;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * m[hm[ht@CɏރNXłB
 * @author stokesia
 */
public class NodeWriter {
    
    private static final Config config = Config.getInstance();
    private static final File nodeFile = new File(config.getDataDirectory(), 
                                                                                        config.getNodeFilename());
    
    /** Creates a new instance of NodeWriter */
    public NodeWriter() {
    }
    
    /**
     * Ŏw肳ꂽm[hm[ht@Cɏ݂܂B
     * @param node ݂m[h
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void write(Node node) throws FileNotFoundException, IOException {
        Node[] nodes = new Node[1];
        nodes[0] = node;
        
        write(nodes);
    }
    
    /**
     *  Ŏw肳ꂽm[hm[ht@Cɏ݂܂B
     * @param line ݂m[h̔z
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void write(Node[] nodes) throws FileNotFoundException, IOException {
        String[] nodeLines = new String[nodes.length];
        
        for(int i = 0; i < nodeLines.length; i++) {
            nodeLines[i] = nodes[i].toString();
        }
        
        MultipleLineWriter.write(nodeLines, nodeFile);
    }
    
    /**
     * Ŏw肳ꂽm[hm[ht@C̖ɏ݂܂B
     * @param node ݂m[h
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void append(Node node) throws FileNotFoundException, IOException {
        Node[] nodes = new Node[1];
        nodes[0] = node;
        
        append(nodes);
    }
    
    /**
     *  Ŏw肳ꂽm[hm[ht@C̖ɏ݂܂B
     * @param line ݂m[h̔z
     * @throws FileNotFoundException t@C݂Ȃꍇ
     * @throws IOException o̓G[ꍇ
     */    
    public static void append(Node[] nodes) throws FileNotFoundException, IOException {
        String[] nodeLines = new String[nodes.length];
        
        for(int i = 0; i < nodeLines.length; i++) {
            nodeLines[i] = nodes[i].toString();
        }
        
        MultipleLineWriter.append(nodeLines, nodeFile);
    }
    
    
}
