/*
 * DeleteCGI.java
 *
 * Created on 2004/10/19, 20:54
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.*;
import java.util.Hashtable;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.server.*;
import net.sourceforge.shingetsu.util.Config;

/**
 * t@C̍폜ALbVt@C̃R[h̍폜sCGIvONX
 * BJ҂͏̃tH[^OLqAANVɎw肷邾ŃR[hAt@
 * C폜s܂B
 * @author stokesia
 */
public class DeleteCGI extends PlugIn {
    
    private Config config = Config.getInstance();
        Hashtable typeNameTable = null;
    
    /** Creates a new instance of DeleteCGI */
    public DeleteCGI() {
        typeNameTable = new Hashtable();
        
        typeNameTable.put(TYPE_LIST, "Xg");
        typeNameTable.put(TYPE_NOTE, "m[g");
        typeNameTable.put(TYPE_THREAD, "Xbh");
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        String command = request.getParameter("command");
        
        if(command == null) {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        } else if(command.equals("comfirm-file-delete")) {
            comfirmDeleteFile(request, response);
	} else if(command.equals("file-delete")) {
            deleteFile(request, response);
        } else if(command.equals("comfirm-delete")) {
            comfirmDeleteRecord(request, response);
        } else if(command.equals("delete")) {
            deleteRecord(request, response);
        } else {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        }
        
    }
    
    private void comfirmDeleteFile(HttpRequest request, HttpResponse response)
        throws HttpProtocolException, IOException {
        if(!isAdminHostAddress(request.getHostAddress())) {
            String message = "̍ڂ𗘗pł̂͊Ǘ҂݂̂łB";
            printAdminError(request, response, message);
            return;
        }

        String menuName = "t@C폜";
        
        String file = request.getParameter("file");
        
        String type = detectType(file);
        String basename = detectBaename(file);
        
        String typeName = (String) typeNameTable.get(type);
        
        String name = null;
        File cacheFile = null;
        
        try {
            name = toString(basename);
            cacheFile = getCacheFile(file);
        } catch(UnsupportedEncodingException e) {            
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NumberFormatException e) {
            String message = "t@C " + cacheFile.getName() + " ̃t@C̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] records = null;
        
        try {
            Cache cache = new Cache(cacheFile);
            
            cache.lock();
            
            records = cache.getRecords();
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "t@C " + cacheFile.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NullPointerException e) {
            String message = "Ŏw肳ꂽt@C " + cacheFile.getName() +  " nullłB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        PrintWriter writer = response.getWriter();

        printHeader(response, writer, menuName);
        printMenu(response, writer, menuName);
        
        writer.println("<p>{ɂ̃t@C폜Ă낵ł?</p>");
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"submit\" value=\"폜\" tabindex=\"6\" accesskey=\"d\" />");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"file-delete\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + file + "\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        writer.println("<p>O:" + name + " ^Cv:" + typeName + "</p>");
        
        int displayEnd = 5;
        int count = 0;
        
        while(count < records.length) {
            if(count < displayEnd) {
                writer.println(records[count] + "<br>");
            } else {
                break;
            }
            count++;
        }
        
        printFooter(response, writer);
    }
    
    private void deleteFile(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        if(!isAdminHostAddress(request.getHostAddress())) {
            String message = "̍ڂ𗘗pł̂͊Ǘ҂݂̂łB";
            printAdminError(request, response, message);
            return;
        }
        
        String file = request.getParameter("file");
        File cacheFile = getCacheFile(file);
        
        try {
            cacheFile.delete();
        } catch(SecurityException e) {
            String message = "t@C " + cacheFile.getName() + " ͍폜邱Ƃł܂łB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String menuName = "menu";
        String encodedMenuName = null;
        
        try {
            encodedMenuName = encode(menuName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String path = "/list.cgi/" + encodedMenuName;

        response.addHeader("Location", path);
        response.setStatusCode(HttpServer.FOUND);
        /*  {SEE OTHER 303X|Xׂ   */
        
        PrintWriter writer = response.getWriter();
        
        writer.flush();
        writer.close();
    }
    
    private void comfirmDeleteRecord(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        if(!isAdminHostAddress(request.getHostAddress())) {
            String message = "̍ڂ𗘗pł̂͊Ǘ҂݂̂łB";
            printAdminError(request, response, message);
            return;
        }
        
        String file = request.getParameter("file");

        String record = request.getParameter("record");
        
        if(record == null) {
            String message = "폜郌R[hw肳Ă܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] tokens = record.split("/");
        
        String timeStamp = tokens[0];
        String id = tokens[1];
        
        long time = 0L;
        
        try {
          time = Long.parseLong(timeStamp);
        } catch(NumberFormatException e) {
            String message = "t@C " + file + " ̎ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        File cacheFile = getCacheFile(file);
        Cache cache = getCache(cacheFile);
        
        String deletedRecord = null;
        
        try {
            cache.lock();
            
            deletedRecord = cache.searchRecord(time, id);
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C "  + cacheFile.getName() + " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NumberFormatException e) {
            String message = "t@C " + cacheFile.getName() + " ̎ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String menuName = "R[h폜";
        String readOnly = "readonly=\"readonly\"";
        
        PrintWriter writer = response.getWriter();

        super.printHeader(response, writer, menuName);
        super.printMenu(response, writer, menuName);

        writer.println("<p>{ɂ̃R[h폜Ă낵ł?</p>");
        
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"delete\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + file + "\" />");
        writer.println("<input type=\"hidden\" name=\"record\" value=\"" + record + "\" />");
        
        if(isRequiredSignature(deletedRecord)) {
            writer.println("<p>̃R[h͏ɂĕی삳Ă܂B͂ĂB</p>");
            writer.println(":<input type=\"password\" name=\"signature\" size=\"30\" tabindex=\"4\" accesskey=\"p\"" + readOnly +  "/>");
            writer.println("<input type=\"hidden\" name=\"required-signature\" value=\"required\" />");
        }
        
        writer.println("<input type=\"submit\" value=\"폜\" tabindex=\"2\" accesskey=\"d\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        writer.println("<p>" + deletedRecord + "</p>");

        super.printFooter(response, writer);
    }
    
    private void deleteRecord(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        if(!isAdminHostAddress(request.getHostAddress())) {
            String message = "̍ڂ𗘗pł̂͊Ǘ҂݂̂łB";
            printAdminError(request, response, message);
            return;
        }
        
        String file = request.getParameter("file");
        
        String type = detectType(file);
        String hexName = detectBaename(file);
        
        String record = request.getParameter("record");
        String[] tokens = record.split("/");

        String timeStamp = tokens[0];
        String id = tokens[1];

        File cacheFile = getCacheFile(file);
        
        long time = 0L;
        
        try {
          time = Long.parseLong(timeStamp);
        } catch(NumberFormatException e) {
            String message = "t@C " + cacheFile.getName() + " ̎ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        Cache cache = getCache(cacheFile);

        try {
            cache.lock();
            
            cache.deleteRecord(time, id);
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C "  + cacheFile.getName() + " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NumberFormatException e) {
            String message = "t@C " + cacheFile.getName() + " ̎ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String encodedName = null;
        
        try {
            String name = toString(hexName);
            encodedName = encode(name);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        response.addHeader("Location", "/" + type + ".cgi/" + encodedName);
        response.setStatusCode(HttpServer.FOUND);
        /*  {SEE OTHER 303X|Xׂ   */
        
        PrintWriter writer = response.getWriter();
        
        writer.flush();
        writer.close();
    }
    
    
    private Cache getCache(File file) throws HttpProtocolException {
        Cache cache = null;
        
	try {
            cache = new Cache(file);
        } catch(NullPointerException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " nullłB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return cache;
    }
    
}
