/*
 * PlugIn.java
 *
 * Created on 2004/10/09, 14:38
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;
import java.io.File;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;
import java.util.Comparator;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.security.MessageDigest;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.cache.NetworkCacheAgent;
import net.sourceforge.shingetsu.cache.CacheManager;
import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.node.NodeList;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.cgi.CGI;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.util.Config;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.lang.SecurityException;
import java.io.UnsupportedEncodingException;
import java.lang.NumberFormatException;
import java.net.MalformedURLException;
import java.security.NoSuchAlgorithmException;

import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * ṼvOCJɂĕKvȋ@\񋟂NXłB
 * @author stokesia
 */
public abstract class PlugIn extends CGI {
    
    /**
     * ^CX^v̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_TIMESTAMP = "time";
    
    /**
     * ʎq̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_ID = "id";
    
    /**
     * {̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_BODY = "body";
    
    /**
     * ^Cv̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_TYPE = "type";
    /**
     * N̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_LINK = "link";

    /**
     * O̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_NAME = "name";

    /**
     * [AhX̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_MAIL = "mail";
    
    /**
     * gq̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_SUFFIX = "suffix";
    
    /**
     * gq̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_ATTACH = "attach";
    
    /**
     * x[X̃^CX^v̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_BASE_STAMP = "base_stamp";
    
    /**
     * x[X̎ʎq̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_BASE_ID = "base_id";
    
    
    /**
     * 폜X^ṽ^CX^v̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_REMOVE_STAMP = "remove_stamp";
    
    /**
     * 폜X^v̎ʎq̖OttB[hL[łB
     */    
    public static final String FIELD_NAME_REMOVE_ID = "remove_id";
    
    /**
     * ^CṽXgłB
     */    
    public static final String TYPE_LIST = "list";
    
    /**
     * ^Cṽm[głB
     */    
    public static final String TYPE_NOTE= "note";
    
    /**
     * ^CṽXbhłB
     */    
    public static final String TYPE_THREAD ="thread";
    
    private Config config = Config.getInstance();
    private Comparator comparator = new PlugIn.SearchRemoveRecordComparator();
    
    private NetworkCacheAgent networkCacheAgent = new NetworkCacheAgent();
    private CacheManager cacheManager = new CacheManager();

    /**
     * vOC̓\bhɋLq܂B̃\bhHttpServerThreadNX
     * vOC̎ŝ߂ɌĂяo܂BvOC̊J҂͂̃\bhI
     * [o[ChKv܂B
     * @param request HttpRequestNX̃IuWFNg
     * @param response HttpResponseNX̃IuWFNg
     * @throws HttpProtocolException sɂȂ炩̗Oꍇ
     * @throws IOException Xg[̓o̓G[ꍇ
     */    
    public abstract void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException;
    
    /**
     * ṼftHg̃wb_o͂܂BAwb_ύX̂ł΁Ã
     * \bhI[o[Ch܂B܂Ã\bh̓X|X̏o̓Xg[
     * JnĂȂꍇ͏o̓Xg[擾Awb_̏o͂Jn܂B
     * @param response ̃NGXgɑ΂HttpResponseNX̃IuWFNg
     * @param writer ̃NGXgɑ΂郌X|X̂߂̏o̓Xg[
     * @param title HTMLhLg̃^Cg
     * @throws HttpProtocolException sɂȂ炩̗Oꍇ
     * @throws IOException Xg[̓o̓G[ꍇ
     */    
    protected void printHeader(HttpResponse response, PrintWriter writer, String title)
            throws HttpProtocolException, IOException {
            if(writer == null) {
                writer = response.getWriter();
            }
            
            assert writer != null;

            writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            writer.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">");
            writer.println("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\">");
            writer.println("<head>");
            writer.println("<meta http-equiv=\"Content-Language\" content=\"ja\" />");
            writer.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
            writer.println("<title>" + title + "</title>");
            writer.println("<link rev=\"made\" href=\"mailto:fuktommy@users.sourceforge.net\" />");
            writer.println("<link rel=\"contents\" href=\"/list.cgi\" />");
            writer.println("<link rel=\"stylesheet\" type=\"text/css\" href=\"/default.css\" />");
            writer.println("</head>");
    }
    
    /**
     * ṼftHg̃j[o͂܂BAj[ύX̂ł΁A
     * ̃\bhI[o[Ch܂B܂Ã\bh̓X|X̏o̓Xg[
     * JnĂȂꍇ͏o̓Xg[擾Aj[o͂Jn܂B
     * ̃\bhprintHeader(HttpResponse, PrintWriter, String)̌ɌĂ΂ׂ
     * B
     * @param response ̃NGXgɑ΂HttpResponseNX̃IuWFNg
     * @param writer ̃NGXgɑ΂郌X|X̂߂̏o̓Xg[
     * @param title HTMLhLg̃^Cg
     * @throws HttpProtocolException sɂȂ炩̗Oꍇ
     * @throws IOException Xg[̓o̓G[ꍇ
     */    
    protected void printMenu(HttpResponse response, PrintWriter writer, String title)
            throws HttpProtocolException, IOException {
            if(writer == null) {
                writer = response.getWriter();
            }
            
            String encodedTitle = encode(title);

            assert writer != null;

            writer.println("<body>");
            writer.println("<p class=\"head\">");
            writer.println("<a href=\"/gateway.cgi\">gbv</a> | ");
            writer.println("<a href=\"/list.cgi\">j[</a> | ");
            writer.println("<a href=\"/gateway.cgi/create\">VK쐬</a> | ");
            writer.println("<a href=\"/gateway.cgi/index\">ꗗ</a> | ");
            writer.println("<a href=\"/gateway.cgi/history\">XV</a> | ");
            writer.println("<a href=\"/gateway.cgi/update\">V</a> | ");
            writer.println("<a href=\"/gateway.cgi/search\"></a>");
            writer.println("</p>");
            writer.println("<h1><a href=\"/gateway.cgi/search/" + encodedTitle +"\" class=\"title\" title=\"\">"+ title + "</a></h1>");
    }
    
    /**
     * t@C쐬tH[o̓Xg[ɏo͂܂B
     * @param response X|X
     * @param writer X|X̏o̓Xg[
     * @param filename 쐬Ώۂ̃t@C
     * @throws IOException o̓G[ꍇ
     * @throws HttpProtocolException HTTPɈᔽȂ炩̃G[ꍇ
     */    
    protected void printCreateFile(HttpResponse response, PrintWriter writer, String filename)
        throws HttpProtocolException, IOException {
        if(writer == null) {
            writer = response.getWriter();
        }
        
        writer.println("<form method=\"get\" action=\"/list.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"create\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + filename + "\" />");
        writer.println("<input type=\"submit\" value=\"VK쐬\" name=\"submit\" tabindex=\"1\" accesskey=\"w\" />");
        writer.println("<input type=\"radio\" value=\"list\" name=\"type\" tabindex=\"2\" accesskey=\"t\" />Xg ");
        writer.println("<input type=\"radio\" value=\"thread\" name=\"type\" tabindex=\"2\" accesskey=\"t\" />Xbh ");
        writer.println("<input type=\"radio\" value=\"note\" name=\"type\" tabindex=\"2\" accesskey=\"t\" />m[g ");
        writer.println("<br>");
        writer.println("O: <input name=\"name\" size=\"19\" value=\"\" tabindex=\"3\" accesskey=\"t\" />");
        writer.println("</p>");
        writer.println("</form>");
    }
    
    /**
     * t@C폜tH[o̓Xg[ɏo͂܂B
     * @param response X|X
     * @param writer X|X̏o̓Xg[
     * @param filename 폜Ώۂ̃t@C
     * @throws IOException o̓G[ꍇ
     * @throws HttpProtocolException HTTPɈᔽȂ炩̗Oꍇ
     */    
    protected void printDeleteFile(HttpResponse response, PrintWriter writer, String filename)
        throws HttpProtocolException, IOException {
        if(writer == null) {
            writer = response.getWriter();
        }
            
        long length = getCacheFile(filename).length();
        String fileLength = getLengthByMB(length) + "MB";
        
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"submit\" value=\"t@C폜\" tabindex=\"6\" accesskey=\"d\" />");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"comfirm-file-delete\" />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + filename + "\" />" + fileLength);
        writer.println("</p>");
        writer.println("</form>");
    }

    /**
     * ṼftHg̃tb^[o͂܂BAtb^[ύX̂ł΁A
     * ̃\bhI[o[Ch܂B܂Ã\bh̓X|X̏o̓Xg
     * [JnĂȂꍇ͏o̓Xg[擾Atb^[̏o͂Jn
     * ܂Btb^[̏o͂IƂ̃\bh͏o̓Xg[tbV
     * ɃN[Y܂B̃\bhprintHeader(HttpResponse, PrintWriter, String)
     * ̌ɌĂ΂ׂłB
     * @param response ̃NGXgɑ΂HttpResponseNX̃IuWFNg
     * @param writer ̃NGXgɑ΂郌X|X̂߂̏o̓Xg[
     * @throws HttpProtocolException sɂȂ炩̗Oꍇ
     * @throws IOException Xg[̓o̓G[ꍇ
     */    
    protected void printFooter(HttpResponse response, PrintWriter writer)
            throws HttpProtocolException, IOException {
            if(writer == null) {
                writer = response.getWriter();
            }
            
            assert writer != null;

            writer.println("</body>");
            writer.println("</html>");
            
            writer.flush();
            writer.close();
    }

    /**
     * ̕16i\ɕϊ܂B
     * @param string ϊ镶
     * @return 16iɕϊꂽ
     * @throws UnsupportedEncodingException ̃GR[fBOT|[gĂȂꍇ
     */    
    public String toHexString(String string) throws UnsupportedEncodingException {
        String encoding = config.getGeneralEncoding();
        
        byte[] bytes = string.getBytes(encoding);
        
        StringBuffer hexStringBuffer = new StringBuffer();
        
        for(int i = 0; i < bytes.length; i++) {
            int value = bytes[i] & 0xFF;
            
            if(value < 16) {
                hexStringBuffer.append("0");
            }
            
            hexStringBuffer.append(Integer.toHexString(value));
        }
        
        return hexStringBuffer.toString().toUpperCase();
    }
    
    /**
     * ŗ^ꂽ\̃AhXǗAhXǂ肵܂B
     * @param hostAddress \̃AhX
     * @return ǗAhXȂtrue
     */    
    public boolean isAdminHostAddress(String hostAddress) {
        String adminHostAddress = config.getAdminHostAddress();
        
        Matcher matcher = Pattern.compile(adminHostAddress).matcher(hostAddress);
        
        boolean result = matcher.matches();
        
        return result;
    }
    
    /**
     * MD5lԂ܂B
     * @param value vZΏۂ̒l
     * @throws UnsupportedEncodingException ̃GR[fBOT|[gĂȂꍇ
     * @throws NoSuchAlgorithmException ASY̎w肪sȏꍇ
     * @return MD5l
     */    
    public String getMD5(String value)
        throws UnsupportedEncodingException, NoSuchAlgorithmException {
        MessageDigest md5 = MessageDigest.getInstance("MD5");
        
        String encoding = config.getGeneralEncoding();
        byte[] valueArray = value.getBytes(encoding);
        
        md5.update(valueArray, 0, valueArray.length);
        byte[] digest = md5.digest();
        
        StringBuffer hexStringBuffer = new StringBuffer();
        
        for(int i = 0; i < digest.length; i++) {
            int n = digest[i] & 0xFF;
            
            if(n < 16) {
                hexStringBuffer.append("0");
            }
            
            hexStringBuffer.append(Integer.toHexString(n));
        }
        
        return hexStringBuffer.toString();
    }
    
    /**
     * 16i\𕶎ɕϊ܂B
     * @param hexString 16i\̕
     * @throws UnsupportedEncodingException GR[fBOT|[gĂȂꍇ
     * @throws NumberFormatException ltH[}bgsȏꍇ
     * @return ϊꂽ
     */    
    public String toString(String hexString)
        throws UnsupportedEncodingException, NumberFormatException {
        int radix = 16;
        String encoding = config.getGeneralEncoding();
        
        int size = hexString.length() / 2;
        byte[] bytes = new byte[size];
        
        for(int i = 0; i < size; i++) {
            String hex = String.valueOf(hexString.charAt(2 * i));
            hex += String.valueOf(hexString.charAt(2 * i + 1));
            
            bytes[i] = (byte) (Integer.parseInt(hex, radix) & 0xFF);
        }
        
        String value = new String(bytes, encoding);
        
        return value;
    }
    
    /**
     * NGXg̃pXXbhAXgȂǂ̖O擾܂BOURLfR[h
     * ĕԂ܂B
     * @param path NGXg̃pX
     * @throws UnsupportedEncodingException URL̃fR[hɎsꍇ
     * @return URLfR[hꂽO
     */    
    public String getName(String path) throws UnsupportedEncodingException {
        String threadName = path.substring(path.lastIndexOf("/") + 1, path.length());
        
        return decode(threadName);
    }
    
    /**
     * LbVt@CFileIuWFNg擾܂B
     * @param filename t@C̖O(16i\prefix_basenamě`)
     * @return LbVt@CFileIuWFNg
     */    
    public File getCacheFile(String filename) {
        String filePath = config.getDataDirectory() + File.separator + filename
                                            + "." + config.getDataFileExtension();

        File file = new File(filePath);
        
        return file;
    }

    /**
     * LbVt@CFileIuWFNg擾܂B
     * @param type 擾t@C̃^Cv
     * @param name 擾O
     * @throws UnsupportedEncodingException Ox[Xl[ɕϊɁAGR[fBOT|[gĂȂꍇ
     * @return LbVt@CFileIuWFNg
     */    
    public File getCacheFile(String type, String name) throws UnsupportedEncodingException {
        String hexThreadName =  toHexString(name);
        
        String filePath = config.getDataDirectory() + File.separator + type+ "_" + hexThreadName
                                            + "." + config.getDataFileExtension();

        File file = new File(filePath);
        
        return file;
    }
    
    /*
    public Cache getCache(File file) throws FileNotFoundException, IOException {
        
    }
     */
    
    /**
     * t@CTCYMB̒Pʂɒ܂B
     * @param length t@CTCY
     * @return MBPʂ̃t@CTCY
     */    
    public long getLengthByMB(long length) {
        return (length / (1024L * 1024L));
    }

    /**
     * bodytB[hɊ܂܂ĂuPbgNɃN쐬܂B
     * @param body bodytB[h
     * @return N쐬ꂽbodytB[h
     * @throws UnsupportedEncodingException w肳ꂽGR[fBOȏꍇ
     */    
    public String createBracketLink(String body)
        throws UnsupportedEncodingException {
        StringBuffer buffer = new StringBuffer();
        int lastIndex = 0;
            
        String regex = "\\[\\[([^/]+)\\]\\]";
        Matcher matcher = Pattern.compile(regex).matcher(body);
        
        while(matcher.find()) {
            int nameGroup = 1;
            
            String name = matcher.group(nameGroup);
            String encodedName = encode(name);
            
            String link = "<a href=\""+ encodedName +"\">[[" + name +  "]]</a>";
            
            matcher.appendReplacement(buffer, link);
            
            StringBuffer tailBuffer = new StringBuffer(buffer.toString());
            matcher.appendTail(tailBuffer);

            lastIndex = matcher.end();
        }
        
        matcher.appendTail(buffer);
        body = buffer.toString();
        
        buffer = new StringBuffer();
        lastIndex = 0;
        
        regex = "\\[\\[([^/]+)/([0-9a-f]+)\\]\\]";
        matcher = Pattern.compile(regex).matcher(body);
        
        while(matcher.find()) {
            int wholeGroup = 0;
            int nameGroup = 1;
            int anchorGroup = 2;
            
            String whole = matcher.group(wholeGroup);
            String name = matcher.group(nameGroup);
            String anchor = matcher.group(anchorGroup);
            
            String encodedName = encode(name);
            
            String link = "<a href=\""+ encodedName + "#r" + anchor + "\">" + whole +  "</a>";
            
            matcher.appendReplacement(buffer, link);
            
            StringBuffer tailBuffer = new StringBuffer(buffer.toString());
            matcher.appendTail(tailBuffer);

            lastIndex = matcher.end();
        }
        
        matcher.appendTail(buffer);
        body = buffer.toString();
        
        buffer = new StringBuffer();
        lastIndex = 0;
        
        regex = "\\[\\[/(" + TYPE_LIST + "|" + TYPE_NOTE + "|" + TYPE_THREAD + ")/([^/\\]]+)\\]\\]";
        matcher = Pattern.compile(regex).matcher(body);

        while(matcher.find()) {
            int wholeGroup = 0;
            int typeGroup = 1;
            int nameGroup = 2;
            
            String whole = matcher.group(wholeGroup);
            String type = matcher.group(typeGroup);
            String name = matcher.group(nameGroup);
            
            String encodedName = encode(name);
            
            String link = "<a href=\"/" + type + ".cgi/" + encodedName + "\">" + whole +  "</a>";
            
            matcher.appendReplacement(buffer, link);
            
            StringBuffer tailBuffer = new StringBuffer(buffer.toString());
            matcher.appendTail(tailBuffer);

            lastIndex = matcher.end();
        }
        
        matcher.appendTail(buffer);
        body = buffer.toString();
        
        buffer = new StringBuffer();
        lastIndex = 0;
        
        regex = "\\[\\[/(" + TYPE_LIST + "|" + TYPE_NOTE + "|" + TYPE_THREAD
                       + ")/([^\\]]+)/([0-9a-f]+)\\]\\]";
        
        matcher = Pattern.compile(regex).matcher(body);
        
        while(matcher.find()) {
            int wholeGroup = 0;
            int typeGroup = 1;
            int nameGroup = 2;
            int anchorGroup = 3;
            
            String whole = matcher.group(wholeGroup);
            String type = matcher.group(typeGroup);
            String name = matcher.group(nameGroup);
            String anchor = matcher.group(anchorGroup);
            
            String encodedName = encode(name);
            
            String link = "<a href=\"/" + type + ".cgi/" + encodedName + "#r" + anchor
                                   +"\">" + whole +  "</a>";
            
            matcher.appendReplacement(buffer, link);
            
            StringBuffer tailBuffer = new StringBuffer(buffer.toString());
            matcher.appendTail(tailBuffer);

            lastIndex = matcher.end();
        } 
        
        matcher.appendTail(buffer);
        body = buffer.toString();
        
        return body;
    }
    
    /**
     * bodytB[hɊ܂܂ĂURLɃN쐬܂B
     * @param body bodytB[h
     * @return N쐬ꂽbodytB[h
     */    
    public String createLink(String body) {
        String httpRegex = "(https|ftp|shttp|http)://[-_.!~*'()a-zA-Z0-9;\\/?:@&=+$,%#]+";
        body = body.replaceAll(httpRegex, "<a href=\"$0\">$0</a>");
        
        String anchorRegex = "&gt;&gt;([0-9a-f]{8})";
        body = body.replaceAll(anchorRegex, "<a href=\"#r$1\">$0</a>");
        
        return body;
    }
    

    /**
     * HTMLŗpłȂGXP[vƓɁAsL&lt;br&gt;^Oɒu
     * ܂B
     * @param body GXP[vbodytB[h
     * @return GXP[vꂽtB[h
     */    
    public String escape(String body) {
        body = super.escape(body);
        
        body = body.replaceAll("\\r?\\n", "<br>");
        
        return body;
    }

    /**
     * GXP[vĂ镶AGXP[vA&lt;br&gt;^OsLCRLFɃA
     * GXP[v܂B
     * @param body bodytB[h
     * @return AGXP[vꂽbodytB[h
     */    
    public String unescape(String body) {
        body = body.replaceAll("<br>", "\r\n");
        
        body = super.unescape(body);

        return body;
    }
    
    /**
     * sCRLF󕶎ɒu܂B
     * @param line uΏۂ̕
     * @return CRLF󕶎ɒu
     */    
    public String replaceCRLF(String line) {
        return line.replaceAll("\\r?\\n$", "");
    }
    
    /**
     * R[h폜R[hǂ𔻒肵܂B
     * @param record R[h
     * @return 폜R[hȂtrue
     */    
    public boolean isRemoveRecord(String record) {
        String removeRegex = "^\\d+<>[0-9a-f]+(<>remove_stamp:(\\d+)<>remove_id:([0-9a-f]+))?";

        Matcher matcher = Pattern.compile(removeRegex).matcher(record);
        boolean result = matcher.matches();
        
        return result;
    }
    
    /**
     * R[hɍ폜VOi܂܂Ă邩ǂo܂B폜VOiƂ
     * remove_stampAremove_idOttB[ĥƂłB
     * @param record R[h
     * @return ܂܂Ătrue
     */    
    public boolean detectRemoveSignal(String record) {
        String removeRegex = "^\\d+<>[0-9a-f]+<>remove_stamp:(\\d+)<>remove_id:([0-9a-f]+)";

        Matcher matcher = Pattern.compile(removeRegex).matcher(record);
        boolean result = matcher.matches();
        
        return result;
    }
    
    /**
     * R[h{܂ނǂԂ܂B̃\bh͖{폜Ăꍇ
     * ̍폜R[h̔ɂp邱Ƃł܂B
     * @param record R[h
     * @return ܂łtrue
     */    
    public boolean hasBody(String record) {
        String removeRegex = "^\\d+<>[0-9a-f]+(<>.*){1}";

        Matcher matcher = Pattern.compile(removeRegex).matcher(record);
        boolean result = matcher.matches();
        
        return result;
    }
    
    //public abstract Hashtable createFieldTable(String record);
    
    /**
     * Ǘ҃[h̃ftHg̃G[y[WX|X̃Xg[ɏo͂܂B
     * @param request HttpRequestNX̃IuWFNg
     * @param response HttpResponseNX̃IuWFNg
     * @param message G[bZ[W
     * @throws IOException o͒ɃG[ꍇ
     * @throws HttpProtocolException HTTP̎dlɈᔽ邩AȂ炩̗Oꍇ
     */    
    protected void printAdminError(HttpRequest request, HttpResponse response, String message)
        throws HttpProtocolException, IOException {
        PrintWriter writer = response.getWriter();
        
        printHeader(response, writer, message);
        printMenu(response, writer, message);
        printFooter(response, writer);
    }
    
    /**
     * m[h̃O[oAhX擾܂B̃\bhNATŕKvƂȂ
     * \bhłB
     * @return m[hAhXB擾łȂnullB
     */    
    public String getGlobalNodeAddress() {
        NodeList nodeList = NodeList.getInstance();
        Node node = nodeList.getAvailableNode();
        
        String[] responses = null;
        String nodeAddress = null;
        
        try {
            responses = node.talk("/ping");
            
            String ipAddress = responses[1];
            String port = Integer.toString(config.getPort());
            String path = "/server.cgi";
            
            nodeAddress = ipAddress + ":" + port + path;
            
        } catch(Exception e) {
            nodeAddress = null;
        } 
        
        return nodeAddress;
    }

    /**
     * ̃m[hɃR[h̃Abvf[gʒm܂B
     * @param nodeAddress ʒm̃m[hAhX
     * @param time R[h̃^CX^v
     * @param filename t@C̖O(16i\prefix_basenamě`)
     * @param id ꂽR[h̎ʎq
     * @throws MalformedURLException m[hAhXsȏꍇ
     */    
    public void informUpdate(String nodeAddress, long time, String filename, String id)
        throws MalformedURLException {
        Node node = new Node(nodeAddress);    
        
        networkCacheAgent.informUpdate(node, filename, time, id);
    }
    
    /**
     * LbV쐬Albg[ÑLbVƓs܂B
     * @param filename t@C̖O(16i\prefix_basenamě`)
     * @throws IOException LbVt@C̏ɃG[ꍇ
     */    
    public void initCache(String filename) throws IOException {
        File cacheFile = getCacheFile(filename);
        
        if(!cacheFile.exists()) {
            cacheFile.createNewFile();
        }
        
        Cache cache = null;
        
        try {
            cache = new Cache(cacheFile);
        } catch(NullPointerException e) {
            System.out.println("t@Cnull̂߃LbVIuWFNg𐶐ł܂B");
            e.printStackTrace();
            return;
        } catch(FileNotFoundException e) {
            throw e;
        }
        
        String timeStamp = "0";
        String timeArgument = timeStamp + "-";
        
        String[] records =  null;
        
        for(int i = 0; i < config.getRetrySearchMax(); i++) {
            records = networkCacheAgent.getRecordsWithHEAD(filename, timeArgument);
            
            if(records != null) {
                break;
            }
        }
        
        if(((records != null) && (records.length == 0)) || (records == null)) {
            return;
        } else {
            try {
                records = cacheManager.difference(cache, records);
            } catch(FileNotFoundException e) {
                throw e;
            }
        }
        
        if((records != null) && (records.length > 0)) {
            String record = records[0];
            
            String[] tokens = record.split("<>");
            timeStamp = tokens[0];
            
            timeArgument =timeStamp + "-";
            
            for(int i = 0; i < config.getRetryGetMax(); i++) {
                records = networkCacheAgent.getRecordsWithGET(filename, timeArgument);
                
                if(records != null) {
                    break;
                }
            }
        }

        if((records != null) && (records.length > 0)) {
            try {
                cacheManager.synchronize(cache, records);
            } catch(NoSuchAlgorithmException e) {
                System.out.println("w肳ĂASY݂͑܂B");
                e.printStackTrace();
            }
        }
        
        try {
            cache.close();
        } catch(IOException e) {
            System.out.println("LbṼN[YŃG[܂B");
            e.printStackTrace();
        }

    }
    
    /**
     * R[hŕی삳Ă邩ǂԂ܂B
     * @param record R[h
     * @return ی삳Ă̂łtrue
     */    
    public boolean isRequiredSignature(String record) {
        String[] tokens = record.split("<>");
        
        Pattern pubkeyPattern = Pattern.compile("^pubkey:");
        Pattern targetPattern = Pattern.compile("^target:");
        Pattern signPattern = Pattern.compile("^sign:");
        
        boolean pubkey = false;
        boolean target = false;
        boolean sign = false;
        
        for(int i = 0; i < tokens.length; i++) {
            if(pubkeyPattern.matcher(tokens[i]).find()) {
                pubkey = true;
            }
            if(targetPattern.matcher(tokens[i]).find()) {
                target = true;
            }
            if(signPattern.matcher(tokens[i]).find()) {
                sign = true;
            }
        }
        
        boolean result = pubkey && target && sign;
        
        return result;
    }
    
    /**
     * prefix_basenamě`̃t@Cx[Xl[o܂B
     * @param filename prefix_basenamě`̃t@C
     * @return t@C
     */    
    public String detectBaename(String filename) {
        int nameGroup = 1;
        
        String regex = "_([0-9A-F]+)";
        Matcher matcher = Pattern.compile(regex).matcher(filename);
        assert matcher.find();
        
        String name = matcher.group(nameGroup);
        
        return name;
    }
    
    /**
     * prefix_basenamě`̃t@C^Cvo܂B
     * @param filename prefix_basenamě`̃t@C
     * @return ^Cv
     */    
    public String detectType(String filename) {
        int typeGroup = 1;
        
        String regex = "(\\w+)_[0-9A-F]+";
        Matcher matcher = Pattern.compile(regex).matcher(filename);
        assert matcher.find();
        
        String name = matcher.group(typeGroup);
        
        return name;
    }

    /**
     * R[hStringz񂩂Vector̃R[hXg쐬܂BR[hXg1
     * vfHashtableō\ĂÃ\bhł̓^CX^vAʎqA{
     * ̃tB[hlƂĎ܂Bꂼ̒lɃANZXɂ͐V̎dlŒ
     * `ĂtB[h̖Ogp܂B
     * @param records R[hStringz
     * @return 1R[hHashtableIuWFNgɂR[hXg
     */    
    public Vector createRecordList(String[] records) {
        int limit = 3;
        
        Vector recordList = new Vector();
        Vector  removedList = new Vector();
        
        Hashtable hashtable = new Hashtable();
        
        for(int i = 0; i < records.length; i++) {
            if(!records[i].matches("\\d+<>[0-9a-f]+(<>.+)?")) {
                continue;
            }

            String[] tokens = records[i].split("<>", limit);
            Hashtable record = (Hashtable) hashtable.clone();

            if(isRemoveRecord(records[i])) {
                if(hasBody(records[i])) {
                    int index = searchRemoveRecordIndex(recordList, tokens[2]);
                    
                    if(index >= 0) {
                        removedList.add(new Integer(index));
                        removedList.add(new Integer(i));
                    }
                }
            } else {
                    record.clear();
                    
                    record.put(FIELD_NAME_TIMESTAMP, tokens[0]);
                    record.put(FIELD_NAME_ID, tokens[1]);
                    record.put(FIELD_NAME_BODY, tokens[2]);
                    
                    recordList.add(record);
            }
        }

        Iterator iterator = removedList.iterator();
        
        while(iterator.hasNext()) {
            int index = ((Integer) iterator.next()).intValue();
            recordList.remove(index);
        }
        
        return recordList;
    }
    
    private int searchRemoveRecordIndex(Vector recordList, String body) {
        int timeStampGroup = 1;
        int idGroup = 2;
        
        /*  remove_stamp:(\d+)<>remove_id:([0-9a-f]+)  */
        String regex = "remove_stamp:(\\d+)<>remove_id:([0-9a-f]+)";
        Pattern pattern = Pattern.compile(regex);

        Matcher matcher = pattern.matcher(body);
        
        assert matcher.matches();

        String timeStamp = matcher.group(timeStampGroup);
        String id = matcher.group(idGroup);
        
        Hashtable key = new Hashtable();
        
        key.put(FIELD_NAME_TIMESTAMP, timeStamp);
        key.put(FIELD_NAME_ID, id);
        
        Object[] recordArray = recordList.toArray();
        
        int index = Arrays.binarySearch(recordArray, key, comparator);

        return index;
    }

    private class SearchRemoveRecordComparator implements Comparator {
        
        public int compare(Object obj1, Object obj2) throws NumberFormatException {
            Hashtable table1 = (Hashtable) obj1;
            Hashtable table2 = (Hashtable) obj2;
            
            String timeStamp1 = (String) table1.get(FIELD_NAME_TIMESTAMP);
            String timeStamp2 = (String) table2.get(FIELD_NAME_TIMESTAMP);
            
            long time1 = Long.parseLong(timeStamp1);
            long time2 = Long.parseLong(timeStamp2);
            
            int result = 0;
            
            if(time1 > time2) {
                result = 1;
            } else if(time1 == time2) {
                String id1 = (String) table1.get(FIELD_NAME_ID);
                String id2 = (String) table2.get(FIELD_NAME_ID);
                
                result = id1.compareTo(id2);
            } else {
                result = -1;
            }
            
            return result;
            
        }
    }

}
