/*
 * ThreadCGI.java
 *
 * Created on 2004/09/05, 21:18
 */

package net.sourceforge.shingetsu.server.cgi;

import java.io.PrintWriter;
import java.io.File;
import java.io.BufferedOutputStream;
import java.lang.Character;
import java.net.URLDecoder;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Map;
import java.util.LinkedList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Comparator;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import net.sourceforge.shingetsu.cache.Cache;
import net.sourceforge.shingetsu.node.Node;
import net.sourceforge.shingetsu.node.NodeList;
import net.sourceforge.shingetsu.server.HttpServer;
import net.sourceforge.shingetsu.server.HttpRequest;
import net.sourceforge.shingetsu.server.HttpResponse;
import net.sourceforge.shingetsu.server.cgi.PlugIn;
import net.sourceforge.shingetsu.util.Config;
import net.sourceforge.shingetsu.util.Time;
import net.sourceforge.shingetsu.util.RecordComparator;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.lang.NullPointerException;
import java.lang.NumberFormatException;
import java.security.NoSuchAlgorithmException;

import net.sourceforge.shingetsu.server.HttpProtocolException;

/**
 * thread.cgiɑCGIvÕNXłB
 * @author stokesia
 */
public class ThreadCGI extends PlugIn {
    
    private Config config = Config.getInstance();
    private Comparator comparator = new RecordComparator();

    /** Creates a new instance of ThreadCGI */
    public ThreadCGI() {
    }
    
    public void excecute(HttpRequest request, HttpResponse response) 
        throws HttpProtocolException, IOException {
        String path = request.getPath();
        String command = request.getParameter("command");
        
        if(command == null) {
            if(path.matches("^/thread.cgi/[^/]+")) {
                /*  regex pattern = ^/thread.cgi/[^/]+  */
                printThreadList(request, response, getName(path));
            } else if(path.matches("^/thread.cgi/([^/]+)/([0-9a-f]+)/(\\d+)\\.(.+)")) {
                /*  regex pattern = ^/thread.cgi/([^/]+)/([0-9a-f]+)/(\d+)\.(.+)  */
                responseAttachmentFile(request, response);
            }  else {
                String message = "vꂽURL " + request.getPath() + " ͌܂łB";
                throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
            }
        } else if(command.equals("post")) {
            postThreadRecord(request, response);
        } else {
            String message = "vꂽURL " + request.getPath() + " ͌܂łB";
            throw new HttpProtocolException(message, HttpServer.NOT_FOUND);
        }

    }
    
    private void printThreadList(HttpRequest request, HttpResponse response, String threadName) 
        throws HttpProtocolException, IOException  {
        String[] threadRecords = getThreadRecords(threadName);
        String[] extensionArray = getExtensionArray();
        String filename = "thread_" + toHexString(threadName);

        String fileLength =  null;
        
        try {
            long length = getCacheFile(TYPE_LIST, threadName).length();
            fileLength = getLengthByMB(length) + "MB";
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        String readOnly = "readonly=\"readonly\"";
        
        /*
        if(isAdminHostAddress(request.getHostAddress())) {
            readOnly = "readonly=\"readonly\"";
        }
         */
        
        PrintWriter writer = response.getWriter();
        
        super.printHeader(response, writer,threadName);
        super.printMenu(response, writer, threadName);
        
        writer.println("<form method=\"get\" action=\"/delete.cgi\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" name=\"command\" value=\"comfirm-delete\"  />");
        writer.println("<input type=\"hidden\" name=\"file\" value=\"" + filename + "\" />");
        writer.println("</p>");
        
        writer.println("<dl>");
        
        if(threadRecords != null) {
            for(int i = 0; i < threadRecords.length; i++) {
                writer.println(threadRecords[i]);
            }
        }
        
        writer.println("</dl>");
        
        writer.println("<p>");
        writer.println("<input type=\"submit\" value=\"R[h폜\" tabindex=\"2\" accesskey=\"d\" />");
        //writer.println("<input type=\"hidden\" name=\"mode\" value=\"thread\" />");
        writer.println("</p>");
        writer.println("</form>");
        
        writer.println("<form method=\"post\" action=\"/thread.cgi\" enctype=\"multipart/form-data\">");
        writer.println("<p>");
        writer.println("<input type=\"hidden\" value=\"post\" name=\"command\" />");
        writer.println("<input type=\"hidden\"  value=\"" + filename + "\" name=\"file\" />");
        writer.println("<input type=\"submit\" value=\"e\" name=\"submit\" tabindex=\"1\" accesskey=\"w\" /> ");
        writer.println("<input type=\"checkbox\" value=\"inform\" name=\"inform\" checked=\"checked\" tabindex=\"2\" accesskey=\"s\" />̃m[hɂʒm ");
        writer.println("<input type=\"checkbox\" value=\"error\" name=\"error\" checked=\"checked\" tabindex=\"2\" accesskey=\"e\" />ݎɌ덷<br>");
        writer.println("O:<input name=\"name\" size=\"15\" value=\"\" tabindex=\"3\" accesskey=\"n\" />");
        writer.println(" E-mail:<input name=\"mail\" size=\"15\" value=\"\" tabindex=\"4\" accesskey=\"m\" />");
        writer.println(" :<input type=\"password\" name=\"signature\" size=\"15\""+ readOnly + "value=\"\" tabindex=\"5\" accesskey=\"p\" /><br>");
        writer.println(" Ytt@C:<input type=\"file\" name=\"attach\" size=\"19\" value=\"\" tabindex=\"6\" accesskey=\"a\" />");
        writer.println(" gq:<select name=\"suffix\" size=\"1\" tabindex=\"7\">");
        
        if(extensionArray != null) {
            writer.println("<option>AUTO</option>");
            
            for(int i = 0; i < extensionArray.length; i++) {
                writer.println("<option>" + extensionArray[i] + "</option>");
            }
        }
        
        writer.println("</select>");
        writer.println("(ő: 10MB)<br>");
        writer.println("<textarea rows=\"5\" cols=\"70\" name=\"message\" tabindex=\"8\" accesskey=\"c\">");
        writer.println("</textarea>");
        writer.println("</p>");
        writer.println("</form>");
        
        super.printDeleteFile(response, writer, filename);
        super.printFooter(response, writer);
        
        threadName = null;
    }
    
    private String[] getExtensionArray() throws HttpProtocolException {
        Hashtable mediaTypeTable = config.getMediaTypeMappingTable();
        Enumeration enumeration = mediaTypeTable.keys();
        
        String[] extensionArray = new String[mediaTypeTable.size()];
        
        for(int i = 0; enumeration.hasMoreElements(); i++) {
            extensionArray[i] = (String) enumeration.nextElement();
        }
        
        return extensionArray;
    }
    
    private String[] getThreadRecords(String threadName) throws HttpProtocolException, IOException {
        File threadFile = null;
        
        try {
            threadFile = getCacheFile(TYPE_THREAD, threadName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] records = null;
        
        String[] tokens = threadFile.getName().split("\\.");
        
        if(!threadFile.exists()) {
            try {
                initCache(tokens[0]);
            } catch (IOException e) {
                String message = "LbVt@C̏ɓo̓G[܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }
        
        if(threadFile.exists()) {
            Cache cache = getCache(threadFile);
            
            cache.lock();
            
            records = cache.getRecords();
            
            cache.unlock();
            cache.close();
            
            Vector recordList = createRecordList(records);
            
            records = createThreadRecords(threadName, recordList);
        }
        
        return records;
    }
    
    private String[] createThreadRecords(String threadName, Vector recordList) 
        throws HttpProtocolException {
        int end = recordList.size();
        
        for(int index = 0; index < end; index++) {
            Hashtable record = (Hashtable) recordList.remove(0);
            
            Hashtable fieldTable = createFieldTable(record);
            record = createMessageRecord(threadName, fieldTable);
            
            recordList.add(record);
        }
        
        Object[] recordArray = recordList.toArray();
        Arrays.sort(recordArray, comparator);
        
        String[] records = new String[recordArray.length];

        for(int i = 0; i < records.length; i++) {
            Hashtable record = (Hashtable) recordArray[i];
            records[i] = (String) record.get(FIELD_NAME_BODY);
        }

        return records;
    }

    private Hashtable createFieldTable(Hashtable record) throws HttpProtocolException {
        int nameGroup = 1;
        int valueGroup = 2;

        String body = (String) record.get(FIELD_NAME_BODY);
        
        /*  regex pattern = (body|name|mail|suffix|attach):(.+)   */
        String regex ="(" + FIELD_NAME_BODY + "|" + FIELD_NAME_NAME + "|"
                                        + FIELD_NAME_MAIL + "|" + FIELD_NAME_SUFFIX + "|"
                                        + FIELD_NAME_ATTACH + "):(.+)";
        
        Pattern pattern = Pattern.compile(regex);
        
        String[] tokens = body.split("<>");
        
        for(int i = 0; i < tokens.length; i++) {
            Matcher matcher = pattern.matcher(tokens[i]);
            
            if(matcher.matches()) {
                String name = matcher.group(nameGroup);
                String value = matcher.group(valueGroup);

                record.put(name, value);
            } else {
                continue;
                //String message = " ʎq " + id + " ̃R[h͏słB";
                //throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
        }

        return record;
    }
    
    private Hashtable createMessageRecord(String threadName, Hashtable fieldTable)
        throws HttpProtocolException {
        String timeStamp = (String) fieldTable.get(FIELD_NAME_TIMESTAMP);
        String id = (String) fieldTable.get(FIELD_NAME_ID);
        String anchor = id.substring(0, 8);
        
        String body = (String) fieldTable.get(FIELD_NAME_BODY);
        String name = (String) fieldTable.get(FIELD_NAME_NAME);
        String mail = (String) fieldTable.get(FIELD_NAME_MAIL);
        
        String suffix = (String) fieldTable.get(FIELD_NAME_SUFFIX);
        String attach = (String) fieldTable.get(FIELD_NAME_ATTACH);
        
        long time = 0;
        
        try {
          time = Long.parseLong(timeStamp) * 1000L;
        } catch(NumberFormatException e) {
            String message = "ʎq " + id + " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        if(name == null) {
            name = "";
        }

        if(mail != null) {
            mail = " [" + mail + "] ";
        } else {
            mail = "";
        }
        
        String attachment = null;
        
        if((suffix != null) && (attach != null)) {
            String encodedName = null;
            
            try {
                encodedName = encode(threadName);
            } catch(UnsupportedEncodingException e){
                String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
                throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
            }
            
            String filename = timeStamp + "." + suffix;
            attachment = " <a href=\"/thread.cgi/" + encodedName + "/" + id + "/" + filename
                                            + "\">" + filename + "</a> ";
        
            byte[] attachArray = decodeBuffer(attach);

            long length = attachArray.length / 1024L;
            attachment = attachment + "(" + length + "KB)";
        } else {
            attachment = "";
        }

        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm");
        String date = dateFormat.format(new Date(time));
        
        body = createLink(body);
        
        try {
            body = createBracketLink(body);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String record = "<dt id=\"r" + anchor + "\">" + "<input type=\"radio\" name=\"record\" "
                                        + "value=\"" + timeStamp + "/" + id +"\" tabindex=\"1\" accesskey=\"s\"/>"
                                        + anchor + " <span class=\"name\">" + name + "</span> " + mail 
                                        + date + attachment + "</dt><dd>" + body + "<br><br></dd>";

        fieldTable.clear();
        
        fieldTable.put(FIELD_NAME_TIMESTAMP, timeStamp);
        fieldTable.put(FIELD_NAME_ID, id);
        fieldTable.put(FIELD_NAME_BODY, record);
        
        return fieldTable;
    }

    private Cache getCache(File file) throws HttpProtocolException {
        Cache cache = null;
        
	try {
            cache = new Cache(file);
        } catch(NullPointerException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " nullłB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + file.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return cache;
    }
    
    private void responseAttachmentFile(HttpRequest request, HttpResponse response) 
        throws IOException, HttpProtocolException {
        String path = request.getPath();
        
        LinkedList attachmentList = parseAttachmentPath(path);
        
        String threadName = (String) attachmentList.removeFirst();
        String hexThreadName = (String) attachmentList.removeFirst();
        String id =  (String) attachmentList.removeFirst();
        String timeStamp =  (String) attachmentList.removeFirst();
        String extension =  (String) attachmentList.removeFirst();
        
        File threadFile = null;
        
        try {
            threadFile = getCacheFile(TYPE_THREAD, threadName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        Cache threadCache= getCache(threadFile);
        
        String record = null;
        long time = 0;
        
        try {
          time = Long.parseLong(timeStamp);
        } catch(NumberFormatException e) {
            String message ="vꂽpX " + path +  " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        try {
            record = threadCache.searchRecord(time, id);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NumberFormatException e) {
            String message ="vꂽpX " + path +  " ̓t̏słB";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String[] records = new String[1];
        records[0] = record;
        
        Vector recordList = createRecordList(records);
        Hashtable threadRecord = (Hashtable) recordList.firstElement();
        Hashtable threadFiledTable = createFieldTable(threadRecord);
        
        String attach = (String) threadFiledTable.get(FIELD_NAME_ATTACH);
        byte[] attachArray = decodeBuffer(attach);
        
        response.addHeader("Content-Length", Long.toString(attachArray.length));
        
        Hashtable mediaTypeTable = config.getMediaTypeMappingTable();
        String contentType = "application/octet-stream";
        
        if(mediaTypeTable.containsKey(extension)) {
            contentType = (String) mediaTypeTable.get(extension);
        }
        
        response.setContentType(contentType);
        
        String filename = timeStamp + "." + extension;
        response.addHeader("Content-disposition", "attachment; filename=\""+ filename +"\"");
        
        BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());
        
        out.write(attachArray, 0, attachArray.length);
        
        out.flush();
        out.close();
    }
    
    private LinkedList parseAttachmentPath(String path) throws HttpProtocolException {
        int threadNameGroup = 1;
        int idGroup = 2;
        int timeStampGroup = 3;
        int extensionGroup = 4;
        
        LinkedList attachmentList = new LinkedList();
        
        /*  regex pattern = ^/thread.cgi/([^/]+)/([0-9a-f]+)/(\d+)\.(.+)   */
        String regex = "^/thread.cgi/([^/]+)/([0-9a-f]+)/(\\d+)\\.(.+)";
        Matcher matcher = Pattern.compile(regex).matcher(path);
        
        assert matcher.matches();
        
        String threadName = null;
        String hexThreadName = null;
        
        try {
            threadName = decode(matcher.group(threadNameGroup));
            hexThreadName = toHexString(threadName);
        } catch(UnsupportedEncodingException e){
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        attachmentList.addLast(threadName); /*  threadName  */
        attachmentList.addLast(hexThreadName);  /*  hexThreadName   */
        attachmentList.addLast(matcher.group(idGroup)); /*  id  */
        attachmentList.addLast(matcher.group(timeStampGroup));  /*  timeStamp   */
        attachmentList.addLast(matcher.group(extensionGroup));  /*  extension   */
        
        return attachmentList;
    }

    private byte[] decodeBuffer(String attach) throws HttpProtocolException {
        BASE64Decoder decoder = new BASE64Decoder();
        byte[] attachArray = null;
        
        try {
            attachArray = decoder.decodeBuffer(attach);
        } catch(IOException e) {
            String message = "BASE64̃fR[fBOɓo̓G[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        return attachArray;
    }
    
    private void postThreadRecord(HttpRequest request, HttpResponse response)
        throws HttpProtocolException, IOException {
        String file = request.getParameter("file");
        String error = request.getParameter("error");
        
        long time = 0L;
        
        if((error != null) && error.equals("error")) {
            time = Time.getCurrentFuzzyTime();
        } else {
            time = Time.getCurrentTime();
        }

        String timeStamp = Long.toString(time);
        
        String body = createBody(request);
        String md5 = null;
        
        try {
            md5 = getMD5(body);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(NoSuchAlgorithmException e) {
            String message = "w肳ꂽnbV֐̃ASY̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String record = timeStamp + "<>" + md5 + "<>" + body;
        
        File cacheFile = getCacheFile(file);   
        Cache cache = getCache(cacheFile);
        
        try {
            cache.lock();
            
            cache.append(record);
            
            cache.unlock();
            cache.close();
        } catch(FileNotFoundException e) {
            String message = "Ŏw肳ꂽt@C " + cacheFile.getName() +  " ݂܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        } catch(IOException e) {
            String message = "t@C̓o͒ɃG[܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }

        String threadName = null;
        String encodedThreadName = null;
        
        try {
            String hexThreadName = detectBaename(file);
            threadName = toString(hexThreadName);
            encodedThreadName = encode(threadName);
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        String anchor = "#r" + md5.substring(0, 8);

        response.addHeader("Location", "/thread.cgi/" + encodedThreadName + anchor);
        response.setStatusCode(HttpServer.FOUND);
        /*  {SEE OTHER 303X|Xׂ   */
        
        PrintWriter writer = response.getWriter();
        
        writer.flush();
        writer.close();

        long SLEEP_TIME = 3000L;
        String informing = request.getParameter("inform");

        if((informing != null) && informing.equals("inform")) {
            for(int i = 1; i <= config.getRetrySearchMax(); i++) {
                try {
                    String nodeAddress = getGlobalNodeAddress();
                    
                    if(nodeAddress != null) {
                        informUpdate(nodeAddress, time, file, md5);
                        break;
                    }
                    
                    Thread.sleep(SLEEP_TIME);
                } catch(Exception e) {
                    e.printStackTrace();
                }
            }
        }

    }

    private String createBody(HttpRequest request) throws HttpProtocolException {
        String name = request.getParameter("name");
        String mail  = request.getParameter("mail");
        String signature = request.getParameter("signature");
        String message = request.getParameter("message");
        
        if((message == null) || (message.length() == 0)) {
            String errorMessage = "bZ[W͂Ă܂B";
            throw new HttpProtocolException(errorMessage, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        StringBuffer body = new StringBuffer();
        
        if(name.length() != 0) {
            body.append("name:" + name + "<>");
        }
        
        if(mail.length() != 0) {
            body.append("mail:" + mail + "<>");
        }
        
        /*  Ŗ{͏̏  */
        /*
        if(signature.length != 0) {
            
        }
         */
        
        if(message.length() != 0) {
            message = message.replaceAll("<", "&lt;");
            message = message.replaceAll(">", "&gt;");
            message = message.replaceAll("\\r?\\n", "<br>");
            
            body.append("body:" + message + "<>");
        }
        
        Map attachmentTable = request.getPart("attach");
        
        String contentDisposition = (String) attachmentTable.get("Content-Disposition");
        Matcher matcher = Pattern.compile("filename=\"([^\"]*)\"").matcher(contentDisposition);
        
        if(matcher.find()) {
            int filenameGroup = 1;
            String filename = matcher.group(filenameGroup);
            
            if(!filename.equals("")) {
                String attachment = (String) attachmentTable.get("attach");
                String extension = request.getParameter("suffix");
                
                if(extension.equals("AUTO")) {
                    extension = detectExtension(attachmentTable);
                }
                
                body.append("suffix:" + extension + "<>");
                
                String encoded = encodeBase64(attachment);
                body.append("attach:" + encoded + "<>");
            }
        }

        return body.toString().replaceAll("<>$", "");
    }
    
    private String detectExtension(Map attachmentTable) {
        String regex = "([^/]+/[^/]+)";
        
        String contentType= (String) attachmentTable.get("Content-Type");
        Matcher matcher = Pattern.compile(regex).matcher(contentType);
        
        assert matcher.find();
        
        String mediaType = matcher.group();
        
        Hashtable mediaTypeMappingTable = config.getMediaTypeMappingTable();
        Enumeration enumeration = mediaTypeMappingTable.keys();
        
        String extension = "bin";
        
        while(enumeration.hasMoreElements()) {
            contentType = (String) enumeration.nextElement();
            
            if(mediaTypeMappingTable.get(contentType).equals(mediaType)) {
                extension = contentType;
                break;
            }
        }

        return extension;
    }
    
    private String encodeBase64(String attachment) throws HttpProtocolException {
        String encoding = config.getGeneralEncoding();
        byte[] attachmentArray = null;
        
        try {
            attachmentArray = attachment.getBytes("ISO-8859-1");
        } catch(UnsupportedEncodingException e) {
            String message = "w肳ꂽGR[fBO̓T|[gĂ܂B";
            throw new HttpProtocolException(message, HttpServer.INTERNAL_SERVER_ERROR);
        }
        
        BASE64Encoder encoder = new BASE64Encoder();
        String encoded = encoder.encodeBuffer(attachmentArray).replaceAll("\\n", "");
        
        return encoded;
    }
    
}
